#!/usr/bin/env python
import sys, ConfigParser
import urllib2
import os.path
from subprocess import call
from urlparse import urlparse

f = open('/etc/anchor/installdir')
install_dir = f.read()
f.close()

config = ConfigParser.ConfigParser()
config.read('%s/Contents/Resources/update.ini' % install_dir)
update_url = config.get('Update', 'url')
version_id = config.get('Update', 'version_id')
if version_id != '754':
	print "Not valid version to fix"
	exit(1)

if os.path.isfile('%s/Contents/Resources/config.ini' % install_dir):
	print "Config file already seems to exist"
	exit(2)

url = urlparse(update_url)
webhost = url.netloc

serverhost = webhost

try:
    response = urllib2.urlopen("http://%s/server/hostname" % webhost, timeout=10)
    serverhost = response.read().strip()
except Exception, e:
    print "invalid response from webhost"
    #exit(3)

call('%s/Contents/MacOS/uninstall_helper' % install_dir)

config_contents = '''[database]
folder = "~/.anchor/db"

[local_server]
interface = 127.0.0.1
port = 1085

[server]
host = {1}
port = 443
site_id =
ssl_crt = "{0}/Contents/Resources/SyncedToolAgent.app/Contents/Resources/server.crt"
webhost = {2}

[db_mgr]
exe = "./db_mgr"
schema = "../Resources/schema"

[agent]
command_file = "{0}/Contents/Resources/command.txt"
reg_file = "~/.anchor/reg.db"
log_settings_file = "~/.anchor/conf/svc_logsettings.ini"
health_report_file = "~/.anchor/conf/health_report"
locks_info_file = "~/.anchor/conf/locks_info"
locks_exts_info_file = "~/.anchor/conf/locks_exts_info"

[gui]
log_settings_file = "~/.anchor/conf/gui_logsettings.ini"

[updater]
exe = "{0}/Contents/Resources/autoupdate.app/Contents/MacOS/osx-intel"
settings_file = "{0}/Contents/Resources/update.ini"
delay = 30
interval = 45

[icon]
program = "{0}/Contents/Resources/program-icon.ico"
folder = "{0}/Contents/Resources/folder-icon.ico"
share = "{0}/Contents/Resources/team-share-icon.icns"'''

with open("%s/Contents/Resources/config.ini" % install_dir, 'wb') as config_file:
	config_file.write(config_contents.format(install_dir, serverhost, webhost))

log_contents = '''[Sinks.logfile]
Destination=TextFileCompressRotate
AutoFlush=false
FileName="~/.anchor/logs/svc_output_%Y-%m-%d_%H-%M-%S_%6N.log"
RotationSize=10485760
Target="~/.anchor/logs"
MaxSize=104857600
ScanForFiles=Matching
Format="%TimeStamp%:%Severity%: %_%"
Filter="%Severity% > debug or (%Channel% != protocol and %Channel% != rpc_service and %Channel% != overlay_query and %Channel% != overlay_status and %Channel% != policy)"

[Sinks.syslog]
Destination=Syslog
Format="%TimeStamp%:%Severity%: %_%"
Filter="%Severity% > normal"'''

with open("%s/Contents/Resources/svc_logsettings.ini" % install_dir, 'wb') as logsettings_file:
	logsettings_file.write(log_contents)

call(["open", install_dir])
exit(0)
